Add script for builtin module building.

This commit introduces a "copy-builtin" script designed to prepare a
kernel source tree for building SPL as a builtin module. The script
makes a full copy of all needed files, thus making the kernel source
tree fully independent of the spl source package.

To achieve that, some compilation flags (-include, -I) have been moved
to module/Makefile. This Makefile is only used when compiling external
modules; when compiling builtin modules, a Kbuild file generated by the
configure-builtin script is used instead. This makes sure Makefiles
inside the kernel source tree does not contain references to the spl
source package.

Signed-off-by: Brian Behlendorf <behlendorf1@llnl.gov>
Issue zfsonlinux/zfs#851
This commit is contained in:
Etienne Dechamps 2012-07-09 11:10:31 +02:00 committed by Brian Behlendorf
parent 723aa3b0c2
commit c167aadb27
5 changed files with 137 additions and 9 deletions

View File

@ -11,5 +11,11 @@ To build packages for your distribution:
$ ./configure $ ./configure
$ make pkg $ make pkg
To copy the kernel code inside your kernel source tree for builtin
compilation:
$ ./configure --enable-linux-builtin --with-linux=/usr/src/linux-...
$ ./copy-builtin /usr/src/linux-...
Full documentation for building, configuring, and using the SPL can Full documentation for building, configuring, and using the SPL can
be found at: <http://zfsonlinux.org> be found at: <http://zfsonlinux.org>

122
copy-builtin Executable file
View File

@ -0,0 +1,122 @@
#!/bin/bash
set -e
usage()
{
echo "usage: $0 <kernel source tree>" >&2
exit 1
}
[ "$#" -eq 1 ] || usage
KERNEL_DIR="$(readlink --canonicalize-existing "$1")"
MODULES=()
for MODULE_DIR in module/*
do
[ -d "$MODULE_DIR" ] || continue
MODULES+=("${MODULE_DIR##*/}")
done
if ! [ -e 'spl_config.h' ]
then
echo >&2
echo " $0: you did not run configure, or you're not in the SPL source directory." >&2
echo " $0: run configure with --with-linux=$KERNEL_DIR and --enable-linux-builtin." >&2
echo >&2
exit 1
fi
make clean || true
rm -rf "$KERNEL_DIR/include/spl" "$KERNEL_DIR/spl"
cp --recursive include "$KERNEL_DIR/include/spl"
cp --recursive module "$KERNEL_DIR/spl"
cp spl_config.h "$KERNEL_DIR/"
adjust_obj_paths()
{
local FILE="$1"
local LINE OBJPATH
while IFS='' read -r LINE
do
OBJPATH="${LINE#\$(MODULE)-objs += }"
if [ "$OBJPATH" = "$LINE" ]
then
echo "$LINE"
else
echo "\$(MODULE)-objs += ${OBJPATH##*/}"
fi
done < "$FILE" > "$FILE.new"
mv "$FILE.new" "$FILE"
}
for MODULE in "${MODULES[@]}"
do
adjust_obj_paths "$KERNEL_DIR/spl/$MODULE/Makefile"
done
cat > "$KERNEL_DIR/spl/Kconfig" <<"EOF"
config SPL
tristate "Solaris Porting Layer (SPL)"
help
This is the SPL library from the ZFS On Linux project.
See http://zfsonlinux.org/
To compile this library as a module, choose M here.
If unsure, say N.
EOF
{
cat <<-"EOF"
SPL_MODULE_CFLAGS = -I$(srctree)/include/spl
SPL_MODULE_CFLAGS += -include $(srctree)/spl_config.h
export SPL_MODULE_CFLAGS
obj-$(CONFIG_SPL) :=
EOF
for MODULE in "${MODULES[@]}"
do
echo 'obj-$(CONFIG_SPL) += ' "$MODULE/"
done
} > "$KERNEL_DIR/spl/Kbuild"
add_after()
{
local FILE="$1"
local MARKER="$2"
local NEW="$3"
local LINE
while IFS='' read -r LINE
do
echo "$LINE"
if [ -n "$MARKER" -a "$LINE" = "$MARKER" ]
then
echo "$NEW"
MARKER=''
if IFS='' read -r LINE
then
[ "$LINE" != "$NEW" ] && echo "$LINE"
fi
fi
done < "$FILE" > "$FILE.new"
mv "$FILE.new" "$FILE"
}
add_after "$KERNEL_DIR/Kconfig" 'source "arch/$SRCARCH/Kconfig"' 'source "spl/Kconfig"'
# We must take care to build SPL before ZFS, else module initialization order will be wrong
sed -i 's#kernel/ mm/ fs/#kernel/ mm/ spl/ fs/#' "$KERNEL_DIR/Makefile"
echo >&2
echo " $0: done." >&2
echo " $0: now you can build the kernel with SPL support." >&2
echo " $0: make sure you enable SPL support (CONFIG_SPL) before building." >&2
echo >&2

View File

@ -3,8 +3,12 @@ subdir-m += splat
INSTALL=/usr/bin/install INSTALL=/usr/bin/install
SPL_MODULE_CFLAGS = -I@abs_top_srcdir@/include
SPL_MODULE_CFLAGS += -include @abs_top_builddir@/spl_config.h
export SPL_MODULE_CFLAGS
modules: modules:
$(MAKE) -C @LINUX_OBJ@ SUBDIRS=`pwd` @KERNELMAKE_PARAMS@ $@ $(MAKE) -C @LINUX_OBJ@ SUBDIRS=`pwd` @KERNELMAKE_PARAMS@ CONFIG_SPL=m $@
clean: clean:
@# Only cleanup the kernel build directories when CONFIG_KERNEL @# Only cleanup the kernel build directories when CONFIG_KERNEL

View File

@ -1,12 +1,10 @@
# Makefile.in for spl kernel module # Makefile.in for spl kernel module
MODULE := spl MODULE := spl
EXTRA_CFLAGS = @KERNELCPPFLAGS@ EXTRA_CFLAGS = $(SPL_MODULE_CFLAGS) @KERNELCPPFLAGS@
EXTRA_CFLAGS += -I@abs_top_srcdir@/include
EXTRA_CFLAGS += -include @abs_top_builddir@/spl_config.h
# Solaris porting layer module # Solaris porting layer module
obj-m := $(MODULE).o obj-$(CONFIG_SPL) := $(MODULE).o
$(MODULE)-objs += @top_srcdir@/module/spl/spl-debug.o $(MODULE)-objs += @top_srcdir@/module/spl/spl-debug.o
$(MODULE)-objs += @top_srcdir@/module/spl/spl-proc.o $(MODULE)-objs += @top_srcdir@/module/spl/spl-proc.o

View File

@ -1,12 +1,10 @@
# Makefile.in for splat kernel module # Makefile.in for splat kernel module
MODULE := splat MODULE := splat
EXTRA_CFLAGS = @KERNELCPPFLAGS@ EXTRA_CFLAGS = $(SPL_MODULE_CFLAGS) @KERNELCPPFLAGS@
EXTRA_CFLAGS += -I@abs_top_srcdir@/include
EXTRA_CFLAGS += -include @abs_top_builddir@/spl_config.h
# Solaris Porting LAyer Tests # Solaris Porting LAyer Tests
obj-m := $(MODULE).o obj-$(CONFIG_SPL) := $(MODULE).o
$(MODULE)-objs += @top_srcdir@/module/splat/splat-ctl.o $(MODULE)-objs += @top_srcdir@/module/splat/splat-ctl.o
$(MODULE)-objs += @top_srcdir@/module/splat/splat-kmem.o $(MODULE)-objs += @top_srcdir@/module/splat/splat-kmem.o